org.eclipse.incquery.runtime.localsearch.planner

## Class LocalSearchPlanner

- java.lang.Object
- - org.eclipse.incquery.runtime.localsearch.planner.LocalSearchPlanner

-     public class LocalSearchPlanner
      extends java.lang.Object

  Author:
    Marton Bur

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `LocalSearchPlanner()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `PDisjunction` | `getFlatDisjunction()`
    `PDisjunction` | `getNormalizedDisjunction()`
    `java.util.List<SubPlan>` | `getPlansForBodies()`
    `void` | `initializePlanner(PQueryFlattener pQueryFlattener, org.apache.log4j.Logger logger, IQueryMetaContext metaContext, IQueryRuntimeContext runtimeContext, PBodyNormalizer pBodyNormalizer, LocalSearchRuntimeBasedStrategy localSearchPlannerStrategy, POperationCompiler pOperationCompiler, java.util.Map<java.lang.String,java.lang.Object> hints)`
    `java.util.Map<java.util.List<ISearchOperation>,java.util.Map<PVariable,java.lang.Integer>>` | `plan(PQuery querySpec, java.util.Set<java.lang.Integer> boundVarIndices)` Creates executable plans for the provided query.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LocalSearchPlanner

          public LocalSearchPlanner()

  - ### Method Detail

    - #### getFlatDisjunction

          public PDisjunction getFlatDisjunction()

    - #### getNormalizedDisjunction

          public PDisjunction getNormalizedDisjunction()

    - #### getPlansForBodies

          public java.util.List<SubPlan> getPlansForBodies()

    - #### initializePlanner

          public void initializePlanner(PQueryFlattener pQueryFlattener,
                                        org.apache.log4j.Logger logger,
                                        IQueryMetaContext metaContext,
                                        IQueryRuntimeContext runtimeContext,
                                        PBodyNormalizer pBodyNormalizer,
                                        LocalSearchRuntimeBasedStrategy localSearchPlannerStrategy,
                                        POperationCompiler pOperationCompiler,
                                        java.util.Map<java.lang.String,java.lang.Object> hints)

    - #### plan

          public java.util.Map<java.util.List<ISearchOperation>,java.util.Map<PVariable,java.lang.Integer>> plan(PQuery querySpec,
                                                                                                                 java.util.Set<java.lang.Integer> boundVarIndices)
                                                                                                          throws QueryProcessingException

      Creates executable plans for the provided query. It is required to call one of the `initializePlanner()` methods before calling this method.
      Parameters:
        `querySpec` -
        `boundVarIndices` - a set of integers representing the variables that are bound
      Returns:
        a mapping between ISearchOperation list and a mapping, that holds a PVariable-Integer mapping for the list of ISearchOperations
      Throws:
        `QueryProcessingException`